# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import pulumi
import pulumi.runtime
from . import utilities, tables

class Provider(pulumi.ProviderResource):
    def __init__(__self__, __name__, __opts__=None, client_certificate_password=None, client_certificate_path=None, client_id=None, client_secret=None, environment=None, msi_endpoint=None, partner_id=None, skip_credentials_validation=None, skip_provider_registration=None, subscription_id=None, tenant_id=None, use_msi=None):
        """
        The provider type for the azurerm package. By default, resources use package-wide configuration
        settings, however an explicit `Provider` instance may be created and passed during resource
        construction to achieve fine-grained programmatic control over provider settings. See the
        [documentation](https://pulumi.io/reference/programming-model.html#providers) for more information.
        
        :param str __name__: The name of the resource.
        :param pulumi.ResourceOptions __opts__: Options for the resource.
        :param pulumi.Input[str] client_certificate_password
        :param pulumi.Input[str] client_certificate_path
        :param pulumi.Input[str] client_id
        :param pulumi.Input[str] client_secret
        :param pulumi.Input[str] environment
        :param pulumi.Input[str] msi_endpoint
        :param pulumi.Input[str] partner_id
        :param pulumi.Input[bool] skip_credentials_validation
        :param pulumi.Input[bool] skip_provider_registration
        :param pulumi.Input[str] subscription_id
        :param pulumi.Input[str] tenant_id
        :param pulumi.Input[bool] use_msi
        """
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, str):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        __props__['client_certificate_password'] = client_certificate_password

        __props__['client_certificate_path'] = client_certificate_path

        if not client_id:
            client_id = (utilities.get_env('ARM_CLIENT_ID') or '')
        __props__['client_id'] = client_id

        if not client_secret:
            client_secret = (utilities.get_env('ARM_CLIENT_SECRET') or '')
        __props__['client_secret'] = client_secret

        if not environment:
            environment = (utilities.get_env('ARM_ENVIRONMENT') or 'public')
        __props__['environment'] = environment

        if not msi_endpoint:
            msi_endpoint = (utilities.get_env('ARM_MSI_ENDPOINT') or '')
        __props__['msi_endpoint'] = msi_endpoint

        __props__['partner_id'] = partner_id

        if not skip_credentials_validation:
            skip_credentials_validation = (utilities.get_env_bool('ARM_SKIP_CREDENTIALS_VALIDATION') or False)
        __props__['skip_credentials_validation'] = pulumi.Output.from_input(skip_credentials_validation).apply(json.dumps) if skip_credentials_validation is not None else None

        if not skip_provider_registration:
            skip_provider_registration = (utilities.get_env_bool('ARM_SKIP_PROVIDER_REGISTRATION') or False)
        __props__['skip_provider_registration'] = pulumi.Output.from_input(skip_provider_registration).apply(json.dumps) if skip_provider_registration is not None else None

        if not subscription_id:
            subscription_id = (utilities.get_env('ARM_SUBSCRIPTION_ID') or '')
        __props__['subscription_id'] = subscription_id

        if not tenant_id:
            tenant_id = (utilities.get_env('ARM_TENANT_ID') or '')
        __props__['tenant_id'] = tenant_id

        if not use_msi:
            use_msi = (utilities.get_env_bool('ARM_USE_MSI') or False)
        __props__['use_msi'] = pulumi.Output.from_input(use_msi).apply(json.dumps) if use_msi is not None else None

        super(Provider, __self__).__init__(
            'azure',
            __name__,
            __props__,
            __opts__)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

