# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import pulumi
import pulumi.runtime
from .. import utilities, tables

class Workspace(pulumi.CustomResource):
    scope: pulumi.Output[str]
    """
    The scope of VMs to send their security data to the desired workspace, unless overridden by a setting with more specific scope.
    """
    workspace_id: pulumi.Output[str]
    """
    The ID of the Log Analytics Workspace to save the data in.
    """
    def __init__(__self__, __name__, __opts__=None, scope=None, workspace_id=None):
        """
        Manages the subscription's Security Center Workspace.
        
        > **NOTE:** Owner access permission is required.
        
        > **NOTE:** The subscription's pricing model can not be `Free` for this to have any affect.
        
        
        :param str __name__: The name of the resource.
        :param pulumi.ResourceOptions __opts__: Options for the resource.
        :param pulumi.Input[str] scope: The scope of VMs to send their security data to the desired workspace, unless overridden by a setting with more specific scope.
        :param pulumi.Input[str] workspace_id: The ID of the Log Analytics Workspace to save the data in.
        """
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, str):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if not scope:
            raise TypeError('Missing required property scope')
        __props__['scope'] = scope

        if not workspace_id:
            raise TypeError('Missing required property workspace_id')
        __props__['workspace_id'] = workspace_id

        super(Workspace, __self__).__init__(
            'azure:securitycenter/workspace:Workspace',
            __name__,
            __props__,
            __opts__)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

